/*
   This process alternates between computing on the CPU, doing I/O, and sleeping.
   After it starts, go to TaskManager, find this process under the "Details" tab,
   and set its "affinity" to just one core. Then go to TaskManager's "Performance"
   tab and you will be able to see that this process does not use any kernel time
   when it is computing, it uses quite a bit of kernel time when it is doing I/O,
   and it doesn't use the CPU at all when it is sleeping.
*/
#include <stdio.h>
#include <windows.h>

int main()
{
   while( 1 )
   {
      // 10 seconds of CPU calculations.
      printf("Compute.\n");
      DWORD clockTicks = GetTickCount();
      while ( GetTickCount() < clockTicks + 10000)
      {
      }

      // 10 seconds of I/O.
      printf("I/O.\n");
      clockTicks = GetTickCount();
      while ( GetTickCount() < clockTicks + 10000)
      {
         printf("abcdefghijklmnopqrstuvwxyz0123456789<>[]");
      }

      // 10 seconds of sleep.
      printf("\nSleep.\n");
      Sleep(10000);
   }
}
